
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] forceInstall] >= 0 } {
    interp expose {} forceInstall
}

proc ::forceInstall { name } {
    foreach rqst { "Init" "InitNumberFFT" "InitFftDirection" "FilterSet" "OffsetReset" "Detect" "DetectStop" "DetectSet_nb_val_fft" "DetectSetThreshold" "MonitorForces" "MonitorForcesStop" "SaveFileFFT" "RecordForces" "DetectiondetectionPosterRead" "MonitormonitorPosterRead" "ForceforcePosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} force$rqst $name
    }
}

interp hide {} forceInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] forceInit] >= 0 } {
    interp expose {} forceInit
}
if { [lsearch [interp hidden] forceInitFormatOutput] >= 0 } {
    interp expose {} forceInitFormatOutput
}

proc ::forceInit { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Init" \
	"Initialisation" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceInit
interp hide {} forceInitFormatOutput





# InitNumberFFT ----------------------------------------------------------

if { [lsearch [interp hidden] forceInitNumberFFT] >= 0 } {
    interp expose {} forceInitNumberFFT
}
if { [lsearch [interp hidden] forceInitNumberFFTFormatOutput] >= 0 } {
    interp expose {} forceInitNumberFFTFormatOutput
}

proc ::forceInitNumberFFT { name args } {
    set format {}
    lappend format [list int "must be a multiple of 2, 3 and 5" 200 ]

    return [ ::cs::rqstSend "${name}" "InitNumberFFT" \
	"Change the number of element to compute the FFT" \
	"int numberFFT\n" \
	1 \
	$format \
	$args ]
}


proc ::forceInitNumberFFTFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceInitNumberFFT
interp hide {} forceInitNumberFFTFormatOutput





# InitFftDirection ----------------------------------------------------------

if { [lsearch [interp hidden] forceInitFftDirection] >= 0 } {
    interp expose {} forceInitFftDirection
}
if { [lsearch [interp hidden] forceInitFftDirectionFormatOutput] >= 0 } {
    interp expose {} forceInitFftDirectionFormatOutput
}

proc ::forceInitFftDirection { name args } {
    set format {}
    lappend format [list double "fftDirection.x" 0.0 ]
    lappend format [list double "fftDirection.y" 0.0 ]
    lappend format [list double "fftDirection.z" 0.0 ]
    lappend format [list double "fftDirection.rx" 0.0 ]
    lappend format [list double "fftDirection.ry" 0.0 ]
    lappend format [list double "fftDirection.rz" 0.0 ]

    return [ ::cs::rqstSend "${name}" "InitFftDirection" \
	"Define the direction of the force for FFT" \
	"Gb_force\n| double x\n| double y\n| double z\n| double rx\n| double ry\n| double rz\n" \
	6 \
	$format \
	$args ]
}


proc ::forceInitFftDirectionFormatOutput { list } {
    set format { {} status { } { fftDirection { } x { } y { } z { } rx { } ry { } rz } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceInitFftDirection
interp hide {} forceInitFftDirectionFormatOutput





# FilterSet ----------------------------------------------------------

if { [lsearch [interp hidden] forceFilterSet] >= 0 } {
    interp expose {} forceFilterSet
}
if { [lsearch [interp hidden] forceFilterSetFormatOutput] >= 0 } {
    interp expose {} forceFilterSetFormatOutput
}

proc ::forceFilterSet { name args } {
    set format {}
    lappend format [list int "filter 2 500Hz" 2 ]

    return [ ::cs::rqstSend "${name}" "FilterSet" \
	"0:8kHz noFilter/1 500Hz/2 125/3 31.5/4 7.8/5 1.95/6 0.488" \
	"int filter\n" \
	1 \
	$format \
	$args ]
}


proc ::forceFilterSetFormatOutput { list } {
    set format { {} status { } filter }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceFilterSet
interp hide {} forceFilterSetFormatOutput





# OffsetReset ----------------------------------------------------------

if { [lsearch [interp hidden] forceOffsetReset] >= 0 } {
    interp expose {} forceOffsetReset
}
if { [lsearch [interp hidden] forceOffsetResetFormatOutput] >= 0 } {
    interp expose {} forceOffsetResetFormatOutput
}

proc ::forceOffsetReset { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "OffsetReset" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceOffsetResetFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceOffsetReset
interp hide {} forceOffsetResetFormatOutput





# Detect ----------------------------------------------------------

if { [lsearch [interp hidden] forceDetect] >= 0 } {
    interp expose {} forceDetect
}
if { [lsearch [interp hidden] forceDetectFormatOutput] >= 0 } {
    interp expose {} forceDetectFormatOutput
}

proc ::forceDetect { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Detect" \
	"To detect grasp of object by human" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceDetectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceDetect
interp hide {} forceDetectFormatOutput





# DetectStop ----------------------------------------------------------

if { [lsearch [interp hidden] forceDetectStop] >= 0 } {
    interp expose {} forceDetectStop
}
if { [lsearch [interp hidden] forceDetectStopFormatOutput] >= 0 } {
    interp expose {} forceDetectStopFormatOutput
}

proc ::forceDetectStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "DetectStop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceDetectStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceDetectStop
interp hide {} forceDetectStopFormatOutput





# DetectSet_nb_val_fft ----------------------------------------------------------

if { [lsearch [interp hidden] forceDetectSet_nb_val_fft] >= 0 } {
    interp expose {} forceDetectSet_nb_val_fft
}
if { [lsearch [interp hidden] forceDetectSet_nb_val_fftFormatOutput] >= 0 } {
    interp expose {} forceDetectSet_nb_val_fftFormatOutput
}

proc ::forceDetectSet_nb_val_fft { name args } {
    set format {}
    lappend format [list int "" 7 ]

    return [ ::cs::rqstSend "${name}" "DetectSet_nb_val_fft" \
	"set nb_val_fft" \
	"int nb_val_fft\n" \
	1 \
	$format \
	$args ]
}


proc ::forceDetectSet_nb_val_fftFormatOutput { list } {
    set format { {} status { } nb_val_fft }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceDetectSet_nb_val_fft
interp hide {} forceDetectSet_nb_val_fftFormatOutput





# DetectSetThreshold ----------------------------------------------------------

if { [lsearch [interp hidden] forceDetectSetThreshold] >= 0 } {
    interp expose {} forceDetectSetThreshold
}
if { [lsearch [interp hidden] forceDetectSetThresholdFormatOutput] >= 0 } {
    interp expose {} forceDetectSetThresholdFormatOutput
}

proc ::forceDetectSetThreshold { name args } {
    set format {}
    lappend format [list double "" 6000 ]

    return [ ::cs::rqstSend "${name}" "DetectSetThreshold" \
	"set threshold" \
	"double threshold\n" \
	1 \
	$format \
	$args ]
}


proc ::forceDetectSetThresholdFormatOutput { list } {
    set format { {} status { } threshold }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceDetectSetThreshold
interp hide {} forceDetectSetThresholdFormatOutput





# MonitorForces ----------------------------------------------------------

if { [lsearch [interp hidden] forceMonitorForces] >= 0 } {
    interp expose {} forceMonitorForces
}
if { [lsearch [interp hidden] forceMonitorForcesFormatOutput] >= 0 } {
    interp expose {} forceMonitorForcesFormatOutput
}

proc ::forceMonitorForces { name args } {
    set format {}
    lappend format [list double "eq.threshold" 0.0 ]
    lappend format [list double "eq.direction.x" 0.0 ]
    lappend format [list double "eq.direction.y" 0.0 ]
    lappend format [list double "eq.direction.z" 0.0 ]
    lappend format [list double "eq.direction.rx" 0.0 ]
    lappend format [list double "eq.direction.ry" 0.0 ]
    lappend format [list double "eq.direction.rz" 0.0 ]

    return [ ::cs::rqstSend "${name}" "MonitorForces" \
	"To detect modification of force in one direction" \
	"FORCE_MONITOR_DATA_STR\n| double threshold\n| Gb_force\n| | double x\n| | double y\n| | double z\n| | double rx\n| | double ry\n| | double rz\n" \
	7 \
	$format \
	$args ]
}


proc ::forceMonitorForcesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceMonitorForces
interp hide {} forceMonitorForcesFormatOutput





# MonitorForcesStop ----------------------------------------------------------

if { [lsearch [interp hidden] forceMonitorForcesStop] >= 0 } {
    interp expose {} forceMonitorForcesStop
}
if { [lsearch [interp hidden] forceMonitorForcesStopFormatOutput] >= 0 } {
    interp expose {} forceMonitorForcesStopFormatOutput
}

proc ::forceMonitorForcesStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "MonitorForcesStop" \
	"Stop MonitorForces activity" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceMonitorForcesStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceMonitorForcesStop
interp hide {} forceMonitorForcesStopFormatOutput





# SaveFileFFT ----------------------------------------------------------

if { [lsearch [interp hidden] forceSaveFileFFT] >= 0 } {
    interp expose {} forceSaveFileFFT
}
if { [lsearch [interp hidden] forceSaveFileFFTFormatOutput] >= 0 } {
    interp expose {} forceSaveFileFFTFormatOutput
}

proc ::forceSaveFileFFT { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SaveFileFFT" \
	"Save a file : # i force fft t fHz" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceSaveFileFFTFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceSaveFileFFT
interp hide {} forceSaveFileFFTFormatOutput





# RecordForces ----------------------------------------------------------

if { [lsearch [interp hidden] forceRecordForces] >= 0 } {
    interp expose {} forceRecordForces
}
if { [lsearch [interp hidden] forceRecordForcesFormatOutput] >= 0 } {
    interp expose {} forceRecordForcesFormatOutput
}

proc ::forceRecordForces { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "RecordForces" \
	"Record RECORD_SIZE forces data and save in file" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::forceRecordForcesFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceRecordForces
interp hide {} forceRecordForcesFormatOutput





# Detectiondetection ----------------------------------------------------------

if { [lsearch [interp hidden] forceDetectiondetectionPosterRead] >= 0 } {
    interp expose {} forceDetectiondetectionPosterRead
}
if { [lsearch [interp hidden] forceDetectiondetectionPosterFormatOutput] >= 0 } {
    interp expose {} forceDetectiondetectionPosterFormatOutput
}

proc ::forceDetectiondetectionPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Detectiondetection" \
	"FORCE_DETECT_STR\n| double threshold\n| double value\n| int nb_val_fft\n| int grasped\n" \
	$args ]
}


proc ::forceDetectiondetectionPosterFormatOutput { list } {
    set format { {} status { } { detection { } threshold { } value { } nb_val_fft { } grasped } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceDetectiondetectionPosterRead
interp hide {} forceDetectiondetectionPosterFormatOutput





# Monitormonitor ----------------------------------------------------------

if { [lsearch [interp hidden] forceMonitormonitorPosterRead] >= 0 } {
    interp expose {} forceMonitormonitorPosterRead
}
if { [lsearch [interp hidden] forceMonitormonitorPosterFormatOutput] >= 0 } {
    interp expose {} forceMonitormonitorPosterFormatOutput
}

proc ::forceMonitormonitorPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Monitormonitor" \
	"FORCE_MONITOR_STR\n| FORCE_MONITOR_DATA_STR\n| | double threshold\n| | Gb_force\n| | | double x\n| | | double y\n| | | double z\n| | | double rx\n| | | double ry\n| | | double rz\n| Gb_force\n| | double x\n| | double y\n| | double z\n| | double rx\n| | double ry\n| | double rz\n| double value\n" \
	$args ]
}


proc ::forceMonitormonitorPosterFormatOutput { list } {
    set format { {} status { } { monitor { } { eq { } threshold { } { direction { } x { } y { } z { } rx { } ry { } rz } } { } { force0 { } x { } y { } z { } rx { } ry { } rz } { } value } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceMonitormonitorPosterRead
interp hide {} forceMonitormonitorPosterFormatOutput





# Forceforce ----------------------------------------------------------

if { [lsearch [interp hidden] forceForceforcePosterRead] >= 0 } {
    interp expose {} forceForceforcePosterRead
}
if { [lsearch [interp hidden] forceForceforcePosterFormatOutput] >= 0 } {
    interp expose {} forceForceforcePosterFormatOutput
}

proc ::forceForceforcePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "Forceforce" \
	"Gb_force\n| double x\n| double y\n| double z\n| double rx\n| double ry\n| double rz\n" \
	$args ]
}


proc ::forceForceforcePosterFormatOutput { list } {
    set format { {} status { } { force { } x { } y { } z { } rx { } ry { } rz } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} forceForceforcePosterRead
interp hide {} forceForceforcePosterFormatOutput


